; LIB CLEAN
; 

    .486                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
; 

    include Common.inc
    
    include LinkedList.inc
    include LinkedList.inc.private

; 
    .data?
      __heap DWORD ?        ; need to define __heap because we're not using MemInit
; 
    .code
; 

;  This function is not exposed
List_New         PROC PRIVATE USES esi hList:DWORD
    mov     esi, hList
    
    MemAlloc eax, [esi].ListHeader.dwListLen
    
    mov     DWORD PTR [eax], LL_STATE_LINK
    
    push    eax
    add     eax, [esi].ListHeader.dwListLen
    sub     eax, [esi].ListHeader.dwItemSize
    
    mov     DWORD PTR [eax+0], LL_STATE_LINK
    mov     DWORD PTR [eax+4], LL_STATE_EOL
    pop     eax
    
    add     eax, [esi].ListHeader.dwItemSize
    ret
List_New         ENDP

; -------------------------------------------------------------------------

List_Create      PROC USES esi hMem:DWORD, dwItemSize:DWORD, dwItemCount:DWORD
    .if(hMem == 0)
        push    0
        call    GetProcessHeap
        mov     hMem, eax
    .endif
    
    move    __heap, eax, hMem
    MemAlloc    esi, SIZEOF ListHeader
    move    [esi].ListHeader.hMem, eax, hMem
    move    [esi].ListHeader.dwItemCount, eax, dwItemCount

    mov     eax, dwItemSize
    add     eax, 4
    move    [esi].ListHeader.dwItemSize, eax
    
    mov     ecx, dwItemCount
    add     ecx, 2
    xor     edx, edx
    mul     ecx
    .if(edx)        ; if overflowed 32-bits
        xor eax, eax
        jmp Abort
    .endif
    move    [esi].ListHeader.dwListLen, eax
    
    push    esi
    call    List_New
    
    mov     [esi].ListHeader.lpFirstEntry, eax
    mov     DWORD PTR [eax], LL_STATE_DEFINED
    
    mov     eax, esi
Abort:    
    ret
List_Create      ENDP

; -------------------------------------------------------------------------

List_Add         PROC   USES esi edi ecx hList:DWORD, lpItem:DWORD
    List_FindNext LL_STATE_IGNORE ; automatically includes LL_STATE_EOL
    
    mov     DWORD PTR [edi], LL_STATE_DEFINED
    
    mov     ecx, hList
    mov     esi, lpItem
    add     edi, 4
    mov     ecx, [ecx].ListHeader.dwItemSize
    sub     ecx, 4
    
    .while(ecx)
        mov al, [esi]
        mov [edi], al
        inc esi
        inc edi
        dec ecx
    .endw
    
    ret
List_Add         ENDP

; -------------------------------------------------------------------------

List_SetLast     PROC    USES esi edi ebx ecx edx hList:DWORD, lpItem:DWORD, lpItemMask:DWORD
    List_FindNext LL_STATE_EOL
    mov     edi, esi
    
    mov     DWORD PTR [edi], LL_STATE_DEFINED

    mov     ecx, hList
    mov     esi, lpItem
    add     edi, 4
    mov     ebx, lpItemMask
    mov     ecx, [ecx].ListHeader.dwItemSize
    sub     ecx, 4
    
    .while(ecx)
        mov al, [esi]
        mov dl, [ebx]
        inc esi
        and al, dl
        not dl
        and [edi], dl
        inc ebx
        or  [edi], al
        inc edi
        dec ecx
    .endw
    
    ret
List_SetLast     ENDP

; -------------------------------------------------------------------------

List_PopLast     PROC    USES esi edi hList:DWORD
    List_FindNext LL_STATE_EOL
    
    mov     DWORD PTR [esi], LL_STATE_EOL
    ret
List_PopLast     ENDP

; -------------------------------------------------------------------------

List_Find       PROC    USES esi edi ebx edx ecx hList:DWORD, dwFirstIndex:DWORD, lpItem:DWORD, lpItemMask:DWORD
    List_FindIndex dwFirstIndex
    
    mov eax, dwFirstIndex
    mov esi, hList
    .while(DWORD PTR [edi] != LL_STATE_EOL)
        mov ecx, [esi].ListHeader.dwItemSize
        sub ecx, 4
        push    esi
        push    edi
        push    ebx
        mov     esi, lpItem
        add     edi, 4
        mov     ebx, lpItemMask
        .while(ecx)
            mov dl, [esi]
            mov dh, [ebx]
            .if(dh)
                and dl, dh
                cmp dl, [edi]
                jne NotEqual
            .endif
            inc esi
            inc ebx
            inc edi
            dec ecx
        .endw
    Equal:
        pop     ebx
        pop     edi
        pop     esi
        jmp     Abort
    NotEqual:
        pop     ebx
        pop     edi
        pop     esi
        add     edi, [esi].ListHeader.dwItemSize
        .if(DWORD PTR [edi] == LL_STATE_LINK)
            mov edi, [edi+4]
            .if(!edi)
                xor eax, eax
                jmp Abort
            .endif
        .endif
        inc     eax
    .endw
    
    xor eax, eax
Abort:
    ret
List_Find       ENDP


; -------------------------------------------------------------------------

List_Get        PROC    USES esi edi edx hList:DWORD, dwIndex:DWORD
    List_FindIndex dwIndex
    
    add edi, 4
    mov eax, edi
Abort:
    ret
List_Get         ENDP

; -------------------------------------------------------------------------

List_Set        PROC    USES esi edi edx ecx hList:DWORD, dwIndex:DWORD, lpItem:DWORD, lpItemMask:DWORD
    List_FindIndex dwIndex
    
    mov     DWORD PTR [edi], LL_STATE_DEFINED
    
    mov     ecx, hList
    mov     esi, lpItem
    add     edi, 4
    mov     ebx, lpItemMask
    mov     ecx, [ecx].ListHeader.dwItemSize
    sub     ecx, 4
    
    .while(ecx)
        mov al, [esi]
        mov dl, [ebx]
        inc esi
        and al, dl
        not dl
        and [edi], dl
        inc ebx
        or  [edi], al
        inc edi
        dec ecx
    .endw
    
Abort:
    ret
List_Set        ENDP

; 


END
