; 

MEM_HEAP    EQU     1


MEMORY_MANAGEMENT_METHOD    EQU MEM_HEAP

; 

IF MEMORY_MANAGEMENT_METHOD EQ MEM_HEAP
; -------------------------------------------------------------------------
    IFNDEF HeapCreate
        include \masm32\include\kernel32.inc
        includelib \masm32\lib\kernel32.lib
    ENDIF

; -------------------------------------------------------------------------
    EXTERNDEF __heap:DWORD

; -------------------------------------------------------------------------

    HEAP_GENERATE_EXCEPTIONS    EQU 4
    HEAP_ZERO_MEMORY            EQU 8

; -------------------------------------------------------------------------

MemInit MACRO mem_size:=<65536>
    .data?
        __heap   DWORD   ?
    .code
    
    invoke  HeapCreate, HEAP_GENERATE_EXCEPTIONS, mem_size, 0
    mov     __heap, eax
ENDM

; -------------------------------------------------------------------------

MemAlloc MACRO address:=<eax>, size
    IFDIFI <address>, <eax>
        push    eax
    ENDIF
    push    ecx
    push    edx
    invoke  HeapAlloc, __heap, HEAP_GENERATE_EXCEPTIONS or HEAP_ZERO_MEMORY, size
    pop     edx
    pop     ecx
    IFDIFI <address>, <eax>
        mov     address, eax
        pop     eax
    ENDIF
ENDM

; -------------------------------------------------------------------------

MemReAlloc MACRO address:=<eax>, size
    IFDIFI <address>, <eax>
        push    eax
    ENDIF
    push    ecx
    push    edx
    invoke  HeapReAlloc, __heap, HEAP_GENERATE_EXCEPTIONS or HEAP_ZERO_MEMORY, address, size
    pop     edx
    pop     ecx
    IFDIFI <address>, <eax>
        mov     address, eax
        pop     eax
    ENDIF
ENDM

; -------------------------------------------------------------------------

MemFree MACRO address
    IFNB <address>
        push    eax
        push    ecx
        push    edx
        invoke  HeapFree, __heap, 0, address
        pop     edx
        pop     ecx
        pop     eax
    ELSE
        .if(__heap)
            invoke  HeapDestroy, __heap
            mov __heap, 0
        .endif
    ENDIF
ENDM

; -------------------------------------------------------------------------
ENDIF
; 
